## tulip 3.6.0dfsg

=== CMakeLists.txt ===
## -----------------------------------------------------------------------------------------------
## ***********************************************************************************************
## -----------------------------------------------------------------------------------------------
##
## Options for cmake (use -D):
## CMAKE_INSTALL_PREFIX=directory_where_tulip_will_be_installed
## NO_DEPRECATE=1 disable display of deprecated warning
##
## -----------------------------------------------------------------------------------------------
## ***********************************************************************************************
## -----------------------------------------------------------------------------------------------

PROJECT(tulip)

CMAKE_MINIMUM_REQUIRED(VERSION 2.6)

IF(NOT MSVC) #visual studio does not recognize these options
   SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wunused")
ENDIF()

IF(WIN32)
	IF(NOT MSVC) #visual studio does not recognize these options 
		
		# Dynamic ling against libstdc++ on win32/MinGW 
		# The second test is for the case where ccache is used (CMAKE_CXX_COMPILER_ARG1 contains the path to the g++ compiler)
		IF (CMAKE_COMPILER_IS_GNUCXX OR "${CMAKE_CXX_COMPILER_ARG1}" MATCHES ".*[g][+][+].*")
			EXECUTE_PROCESS(COMMAND ${CMAKE_CXX_COMPILER} ${CMAKE_CXX_COMPILER_ARG1} -dumpversion
							OUTPUT_VARIABLE GCXX_VERSION)
							
			IF(GCXX_VERSION VERSION_GREATER 4.0)
		
				#SET(CMAKE_EXE_LINKER_FLAGS_DEBUG "${CMAKE_EXE_LINKER_FLAGS_DEBUG} -Wl,-subsystem,console")
				#SET(CMAKE_MODULE_LINKER_FLAGS_DEBUG "${CMAKE_EXE_LINKER_FLAGS_DEBUG} -Wl,-subsystem,console")
				#SET(CMAKE_SHARED_LINKER_FLAGS_DEBUG "${CMAKE_EXE_LINKER_FLAGS_DEBUG} -Wl,-subsystem,console")

				SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D_GLIBCXX_DLL")
				SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} --shared-libgcc -Wl,--allow-multiple-definition")
				SET(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} --shared-libgcc  -Wl,--allow-multiple-definition")
				SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} --shared-libgcc  -Wl,--allow-multiple-definition")
	  
			ENDIF()
			IF(GCXX_VERSION VERSION_GREATER 4.4 OR GCXX_VERSION VERSION_EQUAL 4.4)
				IF(GCXX_VERSION VERSION_LESS 4.5)
					SET(CMAKE_CXX_STANDARD_LIBRARIES "${CMAKE_CXX_STANDARD_LIBRARIES} -lstdc++_s")
				ENDIF()
			ENDIF()	
			IF(GCXX_VERSION VERSION_GREATER 4.5 OR GCXX_VERSION VERSION_EQUAL 4.5)
				SET(CMAKE_CXX_STANDARD_LIBRARIES "${CMAKE_CXX_STANDARD_LIBRARIES} -lstdc++")
			ENDIF()
	ENDIF()
 ENDIF()
ENDIF()

## -----------------------------------------------------------------------------------------------
## build type detection
IF(CMAKE_BUILD_TYPE MATCHES "[Dd][Ee][Bb][Uu][Gg]")
   SET(CMAKE_DEBUG_MODE TRUE)
ELSE(CMAKE_BUILD_TYPE MATCHES "[Dd][Ee][Bb][Uu][Gg]")
   SET(CMAKE_DEBUG_MODE FALSE)
ENDIF(CMAKE_BUILD_TYPE MATCHES "[Dd][Ee][Bb][Uu][Gg]")
## -----------------------------------------------------------------------------------------------
## Tulip version numbers
## TulipVersion : Ma.Mi.Re
## TulipMMVersion : Ma.Mi
## -----------------------------------------------------------------------------------------------
SET(TulipMajorVersion 3)
SET(TulipMinorVersion 6)
SET(TulipReleaseVersion 0)
SET(TulipVersionSeparator .)
IF(MSVC) #specific options for Visual Studio
	IF(${CMAKE_GENERATOR} MATCHES "Visual Studio 9") #visual studio 2008 needs boost
		find_package(BOOST REQUIRED)
		include_directories(${Boost_INCLUDE_DIRS})
		include_directories(${Boost_INCLUDE_DIRS}/boost/tr1)
	ENDIF()
   SET(TulipVersionSeparator _)
ENDIF()
SET(TulipVersion "${TulipMajorVersion}${TulipVersionSeparator}${TulipMinorVersion}${TulipVersionSeparator}${TulipReleaseVersion}")
SET(TulipMMVersion "${TulipMajorVersion}${TulipVersionSeparator}${TulipMinorVersion}")
SET(TulipIntVersion "${TulipMajorVersion}${TulipMinorVersion}${TulipReleaseVersion}")

## -----------------------------------------------------------------------------------------------
## Lib names
## -----------------------------------------------------------------------------------------------
SET(LibTulipName "tulip-${TulipMMVersion}")
SET(LibTulipOglName "tulip-ogl-${TulipMMVersion}")
SET(LibTulipQtName "tulip-qt4-${TulipMMVersion}")
SET(LibTulipOGDFName "tulip-ogdf-${TulipMMVersion}")
SET(LibTulipPluginsManagerName "tulip-pluginsmanager-${TulipMMVersion}")
SET(LibStlPythonName "stlpython")
SET(LibTulipPythonName "tulippython")

## -----------------------------------------------------------------------------------------------
## Find need packages
## -----------------------------------------------------------------------------------------------
FIND_PACKAGE(Freetype REQUIRED)
FIND_PACKAGE(Qt4 4.7.0 REQUIRED)
INCLUDE(${QT_USE_FILE})
IF(DEFINED CMAKE_VERSION)
  SET(HAVE_QT4_GET_MOC_FLAGS TRUE)
ELSE(DEFINED CMAKE_VERSION)
  MACRO (QT4_GET_MOC_FLAGS _moc_flags)
     SET(${_moc_flags})
     GET_DIRECTORY_PROPERTY(_inc_DIRS INCLUDE_DIRECTORIES)

     FOREACH(_current ${_inc_DIRS})
        SET(${_moc_flags} ${${_moc_flags}} "-I${_current}")
     ENDFOREACH(_current ${_inc_DIRS})

     GET_DIRECTORY_PROPERTY(_defines COMPILE_DEFINITIONS)
     FOREACH(_current ${_defines})
        SET(${_moc_flags} ${${_moc_flags}} "-D${_current}")
     ENDFOREACH(_current ${_defines})

     IF(Q_WS_WIN)
       SET(${_moc_flags} ${${_moc_flags}} -DWIN32)
     ENDIF(Q_WS_WIN)

  ENDMACRO(QT4_GET_MOC_FLAGS)
ENDIF(DEFINED CMAKE_VERSION)
FIND_PACKAGE(OpenGL REQUIRED)
FIND_PACKAGE(JPEG REQUIRED)
IF(JPEG_FOUND)
   SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DHAVE_LIBJPEG")
ENDIF(JPEG_FOUND)
FIND_PACKAGE(PNG REQUIRED)
IF(PNG_FOUND)
   SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DHAVE_LIBPNG")
ENDIF(PNG_FOUND)

INCLUDE(FindGLEW.cmake)
IF(NOT GLEW_FOUND)
   message(FATAL_ERROR "Cannot find the GLEW library (required)")
ENDIF(NOT GLEW_FOUND)
INCLUDE(FindXML2.cmake)
IF(NOT LIBXML2_FOUND)
   message(FATAL_ERROR "Cannot find the XML2 library (required)")
ENDIF(NOT LIBXML2_FOUND)

## -----------------------------------------------------------------------------------------------
## OpenMP
## -----------------------------------------------------------------------------------------------

FIND_PACKAGE (Threads)
FIND_PACKAGE(OpenMP QUIET)
IF(OPENMP_FOUND)
   SET(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} ${OpenMP_CXX_FLAGS}")
   SET(OPENMP_CXX_FLAGS "${OpenMP_CXX_FLAGS}")
   IF(WIN32)
	  IF(MSVC)
		SET(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /openmp")
		SET(OPENMP_CXX_FLAGS "/openmp")
	  ELSE()
		SET(CMAKE_CXX_STANDARD_LIBRARIES "${CMAKE_CXX_STANDARD_LIBRARIES} -lgomp ${CMAKE_THREAD_LIBS_INIT}")
		SET(OPENMP_LIBRARIES "-lgomp -lpthread")
	  ENDIF()
   ENDIF()
ELSE(OPENMP_FOUND)
  IF(WIN32)
   STRING(COMPARE NOTEQUAL "${OpenMP_C_FLAGS}" "" OMP_CFLAGS)
   IF(OMP_CFLAGS)
      ## HACK: do not know why OpenMP_CXX_FLAGS
      ## is not set when running on window ?
      SET(CMAKE_CXX_FLAGS_RELEASES "${CMAKE_CXX_FLAGS_RELEASE} ${OpenMP_C_FLAGS}")
      SET(OPENMP_CXX_FLAGS "${OpenMP_C_FLAGS}")
      SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} ${OpenMP_C_FLAGS}")
      SET(OPENMP_LINKER_FLAGS "${OpenMP_C_FLAGS}")
      SET(CMAKE_CXX_STANDARD_LIBRARIES "${CMAKE_CXX_STANDARD_LIBRARIES} -lgomp -lpthread")
      SET(OPENMP_LIBRARIES "-lgomp -lpthread")
      SET(OPENMP_FOUND TRUE)
   ELSE(OMP_CFLAGS)
      MESSAGE("OpenMP not found: multithreaded code will not be used")
   ENDIF(OMP_CFLAGS)
  ELSE(WIN32)
    MESSAGE("OpenMP not found: multithreaded code will not be used")
  ENDIF(WIN32)
ENDIF(OPENMP_FOUND)

## -----------------------------------------------------------------------------------------------
## Python (not required)
## -----------------------------------------------------------------------------------------------

# Try to find Python in first place

# If Python is present, compile SIP before launching the whole Tulip build  
# because we need it later in the configure process 

FIND_PACKAGE(PythonLibs)
FIND_PACKAGE(PythonInterp)

IF(PYTHONLIBS_FOUND AND PYTHONINTERP_FOUND)
  SET(SIP_LIB sip)
  TRY_COMPILE(SIP_OK ${CMAKE_CURRENT_BINARY_DIR}/thirdparty/sip-4.12.1/sipgen ${CMAKE_CURRENT_SOURCE_DIR}/thirdparty/sip-4.12.1/sipgen sip CMAKE_FLAGS -DCMAKE_OSX_ARCHITECTURES=${CMAKE_OSX_ARCHITECTURES})
  IF(SIP_OK)
    IF(WIN32 AND EXISTS "${CMAKE_CURRENT_BINARY_DIR}/thirdparty/sip-4.12.1/sipgen/Debug/sip.exe")
      SET(SIP_EXE ${CMAKE_CURRENT_BINARY_DIR}/thirdparty/sip-4.12.1/sipgen/Debug/sip.exe)
    ELSE()
      SET(SIP_EXE ${CMAKE_CURRENT_BINARY_DIR}/thirdparty/sip-4.12.1/sipgen/sip)
    ENDIF()
    SET(SIP_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/thirdparty/sip-4.12.1/siplib/)
  ENDIF(SIP_OK)
ENDIF(PYTHONLIBS_FOUND AND PYTHONINTERP_FOUND)

## -----------------------------------------------------------------------------------------------
## Include file paths
## -----------------------------------------------------------------------------------------------
SET(GZStreamInclude ${PROJECT_SOURCE_DIR}/thirdparty/gzstream/)
SET(FTGLInclude ${PROJECT_SOURCE_DIR}/thirdparty/ftgl/)
SET(qscintilla2Include ${PROJECT_SOURCE_DIR}/thirdparty/QScintilla-gpl-2.4.6/Qt4/)
SET(OGDFInclude ${PROJECT_SOURCE_DIR}/thirdparty/OGDF)
SET(OGDFLibrary OGDF)
SET(TulipInclude ${PROJECT_SOURCE_DIR}/library/tulip/include/)
SET(TulipBuildInclude ${PROJECT_BINARY_DIR}/library/tulip/include/)
SET(TulipOGLInclude ${PROJECT_SOURCE_DIR}/library/tulip-ogl/include/)
SET(TulipOGDFInclude ${PROJECT_SOURCE_DIR}/library/tulip-ogdf/)
SET(TulipQtInclude ${PROJECT_SOURCE_DIR}/library/tulip-qt/include/)
SET(TulipQtBuildInclude ${PROJECT_BINARY_DIR}/library/tulip-qt/include/)
SET(TulipPluginsManagerInclude ${PROJECT_SOURCE_DIR}/software/plugins-manager/include/)

## -----------------------------------------------------------------------------------------------
## Install paths
## -----------------------------------------------------------------------------------------------
IF(APPLE)
SET(TulipAppleContentsDir Tulip-${TulipVersion}.app/Contents/)
SET(TulipBinInstallDir ${TulipAppleContentsDir}MacOS/)
SET(TulipLibInstallDir ${TulipAppleContentsDir}Frameworks/)
SET(TulipIncludeInstallDir ${TulipAppleContentsDir}include/)
SET(TulipShareInstallDir ${TulipAppleContentsDir}share/tulip)
SET(TulipPluginsInstallDir ${TulipAppleContentsDir}lib/tulip/)
SET(TulipBitmapInstallDir ${TulipShareInstallDir}/bitmaps/)
SET(TulipAppleResourcesDir ${TulipAppleContentsDir}Resources/)
ELSE()
SET(TulipLibInstallDir lib/)
SET(TulipPluginsInstallDir ${TulipLibInstallDir}/tulip/)
SET(TulipBinInstallDir bin/)
SET(TulipIncludeInstallDir include/)
SET(TulipShareInstallDir share/tulip)
SET(TulipBitmapInstallDir ${TulipShareInstallDir}/bitmaps/)
ENDIF()

## -----------------------------------------------------------------------------------------------
## Set UseTulip file name
## -----------------------------------------------------------------------------------------------
SET(TulipUseFile UseTulip.cmake)

## -----------------------------------------------------------------------------------------------
## Disable deprecated compilation output
## -----------------------------------------------------------------------------------------------
if (DEFINED NO_DEPRECATED)
   SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated")
endif (DEFINED NO_DEPRECATED)

## -----------------------------------------------------------------------------------------------
## Disable process to make MainController plugin (for developpers)
## -----------------------------------------------------------------------------------------------
SET(TULIP_USE_MAIN_CONTROLLER ON CACHE BOOL "Link Main controller plugin")
IF(NOT TULIP_USE_MAIN_CONTROLLER)
SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DWITHOUT_MAIN_CONTROLLER")
ENDIF(NOT TULIP_USE_MAIN_CONTROLLER)

## -----------------------------------------------------------------------------------------------
## Disable process to make MainController plugin (for developpers)

=== docs/CMakeLists.txt ===
IF(LINUX)
  FIND_PACKAGE(Doxygen)
  
  IF(DOXYGEN_FOUND)
    SET(TULIP_LIB_DESC "Tulip Graph Library")
    SET(TULIP_LIB_NAME "tulip")
    CONFIGURE_FILE("doxygen/tulip-lib.doxygen.in" "${CMAKE_CURRENT_BINARY_DIR}/doxygen/tulip-lib.doxygen" @ONLY)
    SET(TULIP_LIB_DESC "Tulip Open GL Library")
    SET(TULIP_LIB_NAME "tulip-ogl")
    CONFIGURE_FILE("doxygen/tulip-lib.doxygen.in" "${CMAKE_CURRENT_BINARY_DIR}/doxygen/tulip-ogl-lib.doxygen" @ONLY)
    SET(TULIP_LIB_DESC "Tulip Qt Library")
    SET(TULIP_LIB_NAME "tulip-qt")
    CONFIGURE_FILE("doxygen/tulip-lib.doxygen.in" "${CMAKE_CURRENT_BINARY_DIR}/doxygen/tulip-qt-lib.doxygen" @ONLY)
    EXEC_PROGRAM(date ARGS "+%Y" OUTPUT_VARIABLE THIS_YEAR)
    CONFIGURE_FILE("doxygen/tulip.html.in" "${CMAKE_CURRENT_BINARY_DIR}/doxygen/tulip.html")
    CONFIGURE_FILE("doxygen/header.html.in" "${CMAKE_CURRENT_BINARY_DIR}/doxygen/header.html")
    CONFIGURE_FILE("doxygen/footer.html.in" "${CMAKE_CURRENT_BINARY_DIR}/doxygen/footer.html")
    CONFIGURE_FILE("doxygen/header-allPlugins.html.in" "${CMAKE_CURRENT_BINARY_DIR}/doxygen/header-allPlugins.html")
    CONFIGURE_FILE("doxygen/tulip-plugins.doxygen.in" "${CMAKE_CURRENT_BINARY_DIR}/doxygen/tulip-plugins.doxygen")
    CONFIGURE_FILE("developerHandbook/gen-devPdf.sh.in" "${CMAKE_CURRENT_BINARY_DIR}/developerHandbook/gen-devPdf.sh")
    CONFIGURE_FILE("userHandbook/gen-userPdf.sh.in" "${CMAKE_CURRENT_BINARY_DIR}/userHandbook/gen-userPdf.sh")
    CONFIGURE_FILE("make_tulip_doc_tarball.sh.in" "${CMAKE_CURRENT_BINARY_DIR}/make_tulip_doc_tarball.sh" @ONLY)

    include_directories(${KDE4_INCLUDES} ${KDE4_INCLUDE_DIR} ${QT_INCLUDES} )

    add_subdirectory(common)
    add_subdirectory(doxygen)
    add_subdirectory(userHandbook)
    add_subdirectory(developerHandbook)

    CONFIGURE_FILE("tulip.qhcp.in" "${CMAKE_CURRENT_BINARY_DIR}/tulip.qhcp" @ONLY)
    ADD_CUSTOM_TARGET(tulip_qhp sh ${PROJECT_SOURCE_DIR}/docs/gen-tulipqhp.sh ${CMAKE_CURRENT_BINARY_DIR}/tulip.qhp)
    ADD_CUSTOM_TARGET(tulip_qch qhelpgenerator ${CMAKE_CURRENT_BINARY_DIR}/tulip.qhp -o ${CMAKE_CURRENT_BINARY_DIR}/tulip${TulipIntVersion}.qch)
    ADD_CUSTOM_TARGET(doc qcollectiongenerator ${CMAKE_CURRENT_BINARY_DIR}/tulip.qhcp -o ${CMAKE_CURRENT_BINARY_DIR}/tulip${TulipIntVersion}.qhc WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

    ADD_DEPENDENCIES(tulip_qhp common_copy dev_toc dev_keywords dox_toc dox_keywords user_toc user_keywords allPlugins-html tulip-libs-html)
    ADD_DEPENDENCIES(tulip_qch tulip_qhp)
    ADD_DEPENDENCIES(doc tulip_qch tulip_qhcp)
  ELSE()
  	MESSAGE("Doxygen not found: unable to generate documentation")
  ENDIF()
ENDIF(LINUX)

add_subdirectory(python)

ADD_CUSTOM_TARGET(doc_generation ALL
${CMAKE_COMMAND} -E touch ${CMAKE_CURRENT_BINARY_DIR}/tulip${TulipIntVersion}.qhc
COMMAND ${CMAKE_COMMAND} -E touch ${CMAKE_CURRENT_BINARY_DIR}/tulip${TulipIntVersion}.qch
COMMENT "Checking if documentation files are present")


INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/tulip${TulipIntVersion}.qhc ${CMAKE_CURRENT_BINARY_DIR}/tulip${TulipIntVersion}.qch
  DESTINATION ${TulipShareInstallDir}
  COMPONENT tulip_doc)

=== externalplugins/CMakeLists.txt ===
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/ ${CMAKE_SOURCE_DIR})
CMAKE_MINIMUM_REQUIRED(VERSION 2.6)

#Automatic subdirectory search for CMakeLists.txt
FILE(GLOB CM_FILES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/*/CMakeLists.txt)

FOREACH(CM_FILE ${CM_FILES})
STRING(REGEX REPLACE "//CMakeLists.txt" "" CM_SUBDIR ${CM_FILE})
ADD_SUBDIRECTORY(${CM_SUBDIR})
ENDFOREACH(CM_FILE)

=== plugins/CMakeLists.txt ===
ADD_SUBDIRECTORY(clustering)
ADD_SUBDIRECTORY(colors)
ADD_SUBDIRECTORY(import)
ADD_SUBDIRECTORY(layout)
ADD_SUBDIRECTORY(metric)
ADD_SUBDIRECTORY(selection)
ADD_SUBDIRECTORY(sizes)
ADD_SUBDIRECTORY(export)
ADD_SUBDIRECTORY(glyph)
ADD_SUBDIRECTORY(view)
ADD_SUBDIRECTORY(interactor)

=== software/CMakeLists.txt ===
ADD_SUBDIRECTORY(plugins-manager)
ADD_SUBDIRECTORY(tulip)
#ADD_SUBDIRECTORY(tlprender)

=== textures/CMakeLists.txt ===
INSTALL(FILES
  arrowSprite.png
  candiSprite.png
  edgeBlomSprite.png
  edgeSpring.png
  titlebarGradient.png
DESTINATION ${TulipBitmapInstallDir}
COMPONENT tulip_textures
)

=== thirdparty/CMakeLists.txt ===
ADD_SUBDIRECTORY(gzstream)
ADD_SUBDIRECTORY(ftgl)
ADD_SUBDIRECTORY(OGDF)

IF(PYTHONLIBS_FOUND AND PYTHONINTERP_FOUND)
IF(SIP_OK)
ADD_SUBDIRECTORY(QScintilla-gpl-2.4.6)
ADD_SUBDIRECTORY(sip-4.12.1)
ENDIF(SIP_OK)
ENDIF(PYTHONLIBS_FOUND AND PYTHONINTERP_FOUND)

=== docs/common/CMakeLists.txt ===
ADD_CUSTOM_TARGET(common_copy ${CMAKE_COMMAND} -E copy_directory ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})

=== docs/developerHandbook/CMakeLists.txt ===
ADD_CUSTOM_TARGET(dev_images ${CMAKE_COMMAND} -E copy_directory ${CMAKE_CURRENT_SOURCE_DIR}/images ${CMAKE_CURRENT_BINARY_DIR}/images)

ADD_CUSTOM_TARGET(dev_html java -cp "${PROJECT_SOURCE_DIR}/thirdparty/saxon/saxon653.jar:${PROJECT_SOURCE_DIR}/thirdparty/saxon/saxon.jar:${PROJECT_SOURCE_DIR}/docs/common:${PROJECT_SOURCE_DIR}/thirdparty/xml-commons/resolver.jar" com.icl.saxon.StyleSheet -x org.apache.xml.resolver.tools.ResolvingXMLReader -y org.apache.xml.resolver.tools.ResolvingXMLReader -r org.apache.xml.resolver.tools.CatalogResolver -u ${PROJECT_SOURCE_DIR}/docs/developerHandbook/index.docbook ${PROJECT_SOURCE_DIR}/docs/common/tulip-html.xsl)

ADD_DEPENDENCIES(dev_html dev_images)

ADD_CUSTOM_TARGET(dev_toc java -cp "${PROJECT_SOURCE_DIR}/thirdparty/saxon/saxon653.jar:${PROJECT_SOURCE_DIR}/thirdparty/saxon/saxon.jar:${PROJECT_SOURCE_DIR}/docs/common:${PROJECT_SOURCE_DIR}/thirdparty/xml-commons/resolver.jar" com.icl.saxon.StyleSheet -x org.apache.xml.resolver.tools.ResolvingXMLReader -y org.apache.xml.resolver.tools.ResolvingXMLReader -r org.apache.xml.resolver.tools.CatalogResolver -o toc.dcf ${PROJECT_SOURCE_DIR}/docs/developerHandbook/index.docbook ${PROJECT_SOURCE_DIR}/docs/common/tulip-toc.xsl install.path="./developerHandbook/html/")

ADD_DEPENDENCIES(dev_toc dev_html) 

ADD_CUSTOM_TARGET(dev_keywords java -cp "${PROJECT_SOURCE_DIR}/thirdparty/saxon/saxon653.jar:${PROJECT_SOURCE_DIR}/thirdparty/saxon/saxon.jar:${PROJECT_SOURCE_DIR}/docs/common:${PROJECT_SOURCE_DIR}/thirdparty/xml-commons/resolver.jar" com.icl.saxon.StyleSheet -x org.apache.xml.resolver.tools.ResolvingXMLReader -y org.apache.xml.resolver.tools.ResolvingXMLReader -r org.apache.xml.resolver.tools.CatalogResolver -o keywords.dcf ${PROJECT_SOURCE_DIR}/docs/developerHandbook/index.docbook ${PROJECT_SOURCE_DIR}/docs/common/tulip-keywords.xsl install.path="./developerHandbook/html/")

ADD_DEPENDENCIES(dev_keywords dev_html)

#INSTALL(DIRECTORY
#  ${CMAKE_CURRENT_BINARY_DIR}/html
#  ${CMAKE_CURRENT_BINARY_DIR}/images
#DESTINATION share/tulip/developerHandbook
#COMPONENT tulip_doc)

=== docs/doxygen/CMakeLists.txt ===
ADD_CUSTOM_TARGET(tulip-libs-html sh ${PROJECT_SOURCE_DIR}/docs/common/gen-index.sh)

ADD_CUSTOM_TARGET(tulip-lib-html doxygen tulip-lib.doxygen WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

ADD_CUSTOM_TARGET(tulip-libogl-html doxygen tulip-ogl-lib.doxygen WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

ADD_CUSTOM_TARGET(tulip-libqt-html doxygen tulip-qt-lib.doxygen WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

ADD_CUSTOM_TARGET(tulip-plugins-doc doxygen tulip-plugins.doxygen WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

ADD_CUSTOM_TARGET(tulipPlugins-html java -cp "${PROJECT_SOURCE_DIR}/thirdparty/saxon/saxon653.jar:${PROJECT_SOURCE_DIR}/thirdparty/saxon/saxon.jar:${PROJECT_SOURCE_DIR}/docs/common:${PROJECT_SOURCE_DIR}/thirdparty/xml-commons/resolver.jar" com.icl.saxon.StyleSheet -x org.apache.xml.resolver.tools.ResolvingXMLReader -y org.apache.xml.resolver.tools.ResolvingXMLReader -r org.apache.xml.resolver.tools.CatalogResolver -o tulipPlugins.html tulip-plugins.tag  ${PROJECT_SOURCE_DIR}/docs/doxygen/dox-plugins.xsl)

ADD_DEPENDENCIES(tulipPlugins-html tulip-plugins-doc)
ADD_DEPENDENCIES(tulip-libs-html tulip-lib-html tulip-libogl-html tulip-libqt-html)

ADD_CUSTOM_TARGET(allPluginsBody-html java -cp "${PROJECT_SOURCE_DIR}/thirdparty/saxon/saxon653.jar:${PROJECT_SOURCE_DIR}/thirdparty/saxon/saxon.jar:${PROJECT_SOURCE_DIR}/docs/common:${PROJECT_SOURCE_DIR}/thirdparty/xml-commons/resolver.jar" com.icl.saxon.StyleSheet -x org.apache.xml.resolver.tools.ResolvingXMLReader -y org.apache.xml.resolver.tools.ResolvingXMLReader -r org.apache.xml.resolver.tools.CatalogResolver -o allPluginsBody.html tulip-plugins.tag ${PROJECT_SOURCE_DIR}/docs/doxygen/dox-html.xsl)

ADD_DEPENDENCIES(allPluginsBody-html tulip-plugins-doc)

ADD_CUSTOM_TARGET(allPlugins-html sh ${PROJECT_SOURCE_DIR}/docs/doxygen/gen-allPlugins.sh)

ADD_DEPENDENCIES(allPlugins-html allPluginsBody-html)

ADD_CUSTOM_TARGET(dox_toc java -cp "${PROJECT_SOURCE_DIR}/thirdparty/saxon/saxon653.jar:${PROJECT_SOURCE_DIR}/thirdparty/saxon/saxon.jar:${PROJECT_SOURCE_DIR}/docs/common:${PROJECT_SOURCE_DIR}/thirdparty/xml-commons/resolver.jar" com.icl.saxon.StyleSheet -x org.apache.xml.resolver.tools.ResolvingXMLReader -y org.apache.xml.resolver.tools.ResolvingXMLReader -r org.apache.xml.resolver.tools.CatalogResolver -o toc.dcf tulip-plugins.tag ${PROJECT_SOURCE_DIR}/docs/doxygen/dox-toc.xsl)

ADD_DEPENDENCIES(dox_toc tulipPlugins-html)

ADD_CUSTOM_TARGET(dox_keywords java -cp "${PROJECT_SOURCE_DIR}/thirdparty/saxon/saxon653.jar:${PROJECT_SOURCE_DIR}/thirdparty/saxon/saxon.jar:${PROJECT_SOURCE_DIR}/docs/common:${PROJECT_SOURCE_DIR}/thirdparty/xml-commons/resolver.jar" com.icl.saxon.StyleSheet -x org.apache.xml.resolver.tools.ResolvingXMLReader -y org.apache.xml.resolver.tools.ResolvingXMLReader -r org.apache.xml.resolver.tools.CatalogResolver -o keywords.dcf tulip-plugins.tag ${PROJECT_SOURCE_DIR}/docs/doxygen/dox-keywords.xsl)

ADD_DEPENDENCIES(dox_keywords tulipPlugins-html)

#INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/tulip.html
#	      ${CMAKE_CURRENT_BINARY_DIR}/tulipdoc.html
#	      ${CMAKE_CURRENT_BINARY_DIR}/allPluginsBody.html
#	      ${CMAKE_CURRENT_BINARY_DIR}/allPlugins.html
#	      ${CMAKE_CURRENT_BINARY_DIR}/tulipPlugins.html
#  DESTINATION share/tulip/doxygen
#  COMPONENT tulip_doc)

#INSTALL(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/tulip-lib
#		  ${CMAKE_CURRENT_BINARY_DIR}/tulip-ogl-lib
#		  ${CMAKE_CURRENT_BINARY_DIR}/tulip-qt-lib
#  DESTINATION share/tulip/doxygen
#  COMPONENT tulip_doc)

=== docs/python/CMakeLists.txt ===
IF(PYTHONINTERP_FOUND AND SIP_OK)
  
SET(Sphinx_DIR ${CMAKE_CURRENT_SOURCE_DIR})
MARK_AS_ADVANCED(Sphinx_DIR)
FIND_PACKAGE(Sphinx)
  
IF(SPHINX_FOUND)

ADD_CUSTOM_TARGET(pythonBindingsDoc ALL ${CMAKE_COMMAND} -DSPHINX_EXECUTABLE=${SPHINX_EXECUTABLE} -DSOURCE_DIR=${CMAKE_CURRENT_SOURCE_DIR} -DBIN_DIR=${CMAKE_CURRENT_BINARY_DIR} -P ${CMAKE_CURRENT_SOURCE_DIR}/genSphinxDoc.cmake
				  DEPENDS ${LibTulipPythonName} ${LibStlPythonName})
				  
SET_DIRECTORY_PROPERTIES(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES "doc;doctrees") 

INSTALL(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/doc 
  DESTINATION ${TulipShareInstallDir}/tulip-python
  COMPONENT tulip_doc)
																 
ELSE(SPHINX_FOUND)
	MESSAGE("Sphinx not found : unable to generate the documentation for the Python bindings.")
ENDIF(SPHINX_FOUND)
  
ENDIF(PYTHONINTERP_FOUND AND SIP_OK)

=== docs/userHandbook/CMakeLists.txt ===
ADD_CUSTOM_TARGET(user_images ${CMAKE_COMMAND} -E copy_directory ${CMAKE_CURRENT_SOURCE_DIR}/images ${CMAKE_CURRENT_BINARY_DIR}/images)

ADD_CUSTOM_TARGET(user_html java -cp "${PROJECT_SOURCE_DIR}/thirdparty/saxon/saxon653.jar:${PROJECT_SOURCE_DIR}/thirdparty/saxon/saxon.jar:${PROJECT_SOURCE_DIR}/docs/common:${PROJECT_SOURCE_DIR}/thirdparty/xml-commons/resolver.jar" com.icl.saxon.StyleSheet -x org.apache.xml.resolver.tools.ResolvingXMLReader -y org.apache.xml.resolver.tools.ResolvingXMLReader -r org.apache.xml.resolver.tools.CatalogResolver -u ${PROJECT_SOURCE_DIR}/docs/userHandbook/index.docbook ${PROJECT_SOURCE_DIR}/docs/common/tulip-html.xsl)

ADD_DEPENDENCIES(user_html user_images)

ADD_CUSTOM_TARGET(user_toc java -cp "${PROJECT_SOURCE_DIR}/thirdparty/saxon/saxon653.jar:${PROJECT_SOURCE_DIR}/thirdparty/saxon/saxon.jar:${PROJECT_SOURCE_DIR}/docs/common:${PROJECT_SOURCE_DIR}/thirdparty/xml-commons/resolver.jar" com.icl.saxon.StyleSheet -x org.apache.xml.resolver.tools.ResolvingXMLReader -y org.apache.xml.resolver.tools.ResolvingXMLReader -r org.apache.xml.resolver.tools.CatalogResolver -o toc.dcf ${PROJECT_SOURCE_DIR}/docs/userHandbook/index.docbook ${PROJECT_SOURCE_DIR}/docs/common/tulip-toc.xsl install.path="./userHandbook/html/")

ADD_DEPENDENCIES(user_toc user_html)

ADD_CUSTOM_TARGET(user_keywords java -cp "${PROJECT_SOURCE_DIR}/thirdparty/saxon/saxon653.jar:${PROJECT_SOURCE_DIR}/thirdparty/saxon/saxon.jar:${PROJECT_SOURCE_DIR}/docs/common:${PROJECT_SOURCE_DIR}/thirdparty/xml-commons/resolver.jar" com.icl.saxon.StyleSheet -x org.apache.xml.resolver.tools.ResolvingXMLReader -y org.apache.xml.resolver.tools.ResolvingXMLReader -r org.apache.xml.resolver.tools.CatalogResolver -o keywords.dcf ${PROJECT_SOURCE_DIR}/docs/userHandbook/index.docbook ${PROJECT_SOURCE_DIR}/docs/common/tulip-keywords.xsl install.path="./userHandbook/html/")

ADD_DEPENDENCIES(user_keywords user_html)

#INSTALL(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html
#		  ${CMAKE_CURRENT_BINARY_DIR}/images 
#  DESTINATION share/tulip/userHandbook
#  COMPONENT tulip_doc)

=== debian/changelog ===
tulip (3.6.0dfsg-2) unstable; urgency=low

  * Don't build docs for tulip-doc from build-arch, move java packages,
    docbook-xsl and doxygen to Build-Depend-Indep (where default-jre-headless
    was, already).  Closes: #639313.  Uses debhelper compat level 9 for this,
    but for unknown reason so we do not get multiarch paths.
  * Drop apparently-useless build-dep on texlive-extra-utils (Closes:
    #616282).
  * Cleanup: merge the 2 gzstream-related patches in debian/patches, since
    the second one was obsoleting the first one.
  * Drop long-useless build-dep on sharutils.
  * Remove docs/doxygen/xml on clean.

 -- Yann Dirson <dirson@debian.org>  Fri, 09 Sep 2011 22:58:34 +0200

tulip (3.6.0dfsg-1) unstable; urgency=low

  * New upstream release (Closes: #617602).
   * Upstream changed build system to cmake, dropping all previous patches.
     Closes: #407855, #559083, #633269 (not applicable any more).
   * Builds correctly with g++-4.5 (Closes: #615687).
   * Deactivate tlprender package, it is neither built nor buildable
     any more. Drop build-dep on libosmesa6-dev.
  * Noted REJECT in previous changelog entry.
  * Converted debian/copyright to DEP-5.
  * Regenerated upstream tarball as tar.bz2 after removing:
    * thirdparty/libgpugraph/: no license, unused upstream
    * thirdparty/{saxon,xml-commons}/: jars only, use debs instead
    * thirdparty/ftgl/: use debs instead
    * thirdparty/{QScintilla-gpl-2.4.6,sip-4.12.1}/: unused for now, see below
  * Kept DEP-5 entries for removed dirs in debian/copyright.nuked
  * Update debian/watch for new upstream naming scheme.
  * Switched build-dep from libjpeg62-dev to libjpeg-dev (Closes:
    #634636).
  * Switched build-dep from libgl1-mesa-swx11-dev to libgl1-mesa-dev |
    libgl-dev (Closes: #560012, #638169).
  * Disable thirdparty/ftgl directory and point to system one.
  * Changed libOGDF lib name to OGDFtlp-3.6.  Ideally we should rely on a
    standalone package for this, but OGDF upstream only build static libs
    anyway, so thirdparty/OGDF is as close to a usable shared lib as we
    can get, I guess... Create new binary package for it.
  * Make the name of the gzstream library tunable via cmake variable.
  * Change libgzstream name to libgzstreamtlp-3.6. Create new binary package
    for it.
  * Disable the python stuff for now even if it would be normally
    activated, it is even more work to get it right.  Will need build-dep
    on at least python-dev, python-sphinx, python-sip-dev,
    python-qscintilla2 when we want to do that.
  * Comment out INSTALL_RPATH flag on executables.  Call cmake with
    -DCMAKE_SKIP_RPATH:BOOL=YES.
  * Factored out references to doc-building jars in cmake files.
  * Use Debian-povided versions of doc-building jars, build-depend on
    libsaxon-java, libxml-commons-resolver1.1-java.

  * Switched to "dh", set compat level to 8.
  * Merge all -dev packages into tulip-dev for packaging convenience.
  * Fix typo in changelog (lintian).
  * Bumped Standards-Version to 3.9.1, no change.

 -- Yann Dirson <dirson@debian.org>  Thu, 25 Aug 2011 02:19:48 +0200

tulip (3.3.1-1) unstable; urgency=low

  * (rejected by ftpmaster because of thirdparty/*).
  * New upstream release.
  * Acknowledge NMUs.
  * Change lib package names to *-3.3.
  * Fixed patch for docbook-xsl catalog: move -D flags before the class
    name, so that also works when sun's jre is the default.
  * Dropped unneeded patches:
    * missing headers for gcc4.4
    * xml markup improvements
  * Regenerated autotools files, this time using autoconf2.59 to match
    upstream.
  * Use packaged ftgl instead of in-source one.
  * Capitalize doc-base section (lintian).
  * Bumped Standards-Version to 3.8.4, no change.

 -- Yann Dirson <dirson@debian.org>  Tue, 29 Jun 2010 22:13:47 +0200

tulip (3.1.2-2.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Change section of generated manpages to .3tulip (Closes: #557054, #558473)
  * urgency set to medium due to RC bug fix

 -- Alexander Reichle-Schmehl <tolimar@debian.org>  Wed, 27 Jan 2010 11:32:43 +0100

tulip (3.1.2-2.2) unstable; urgency=low

  * Non-maintainer upload.
  * Added missing headers for gcc4.4 (Closes: #527215) 

 -- Meike Reichle <meike@debian.org>  Sat, 23 Jan 2010 23:46:34 +0100

tulip (3.1.2-2.1) unstable; urgency=low

  * Non-maintainer upload.
  * Use ttf-dejavu instead of ttf-bitstream-vera (now gone), patch from
    James Westby (Closes: #528152)
  * Add build-dep on texlive-extra-utils for epstopdf
  * Use local docbook-xsl catalog for saxon instead of relying on network
    access, patch from James Westby

 -- Stefano Zacchiroli <zack@debian.org>  Mon, 23 Nov 2009 17:26:36 +0100

tulip (3.1.2-2) unstable; urgency=low

  * Fixed install target to cope with arch-dep-only builds (Closes:
    #526968).
  * Rename all manpages to .3tlp to avoid conflicting with various other
    pacakges (Closes: #526951).

 -- Yann Dirson <dirson@debian.org>  Mon, 04 May 2009 21:43:57 +0200

tulip (3.1.2-1) unstable; urgency=low

  * New upstream beta release, new shared-libs packages (Closes: #476008,
    #479327).
  * New packages for libtulip-pluginsmanager.
  * Drop version from -dev package names.
  * Use ${binary:Version} for versionning dependencies.
  * Automate dispatching header files into -dev packages (it was about
    time I get a round tuit...).
  * Build with --enable-tlprender --enable-stats-gui
  * Include tulip_check_pl in tulip package for now.
  * Build-depend on libglew1.5-dev and libqt4-opengl-dev.
  * Build-depend on libftgl-dev instead of transitionnal ftgl-dev.
  * Deactivate use of system ftgl, since 2.1.3 seems to drop backward
    compatibility.  
  * Build manuals using upstream Makefiles, build-depend on
    default-jre-headless instead of xmltex and xmlto (Closes: #419532).
  * Fixed debhelper flags for binary-indep target.
  * Ship library manpages and other doxygen-generated docs.
  * Added Homepage field to debian/control.


=== debian/control ===
Source: tulip
Section: graphics
Priority: optional
Maintainer: Yann Dirson <dirson@debian.org>
Build-Depends: debhelper (>> 8), cmake, libqt4-dev, qt4-dev-tools, freeglut3-dev, docbook-to-man, libgl1-mesa-dev | libgl-dev, dh-buildinfo, libfreetype6-dev, libxml2-dev, libgle3-dev, libxml2-utils, graphviz, libjpeg-dev, libpng12-dev, libftgl-dev, libglew1.5-dev, libqt4-opengl-dev
Build-Depends-Indep: default-jre-headless, libsaxon-java, libxml-commons-resolver1.1-java, docbook-xsl, doxygen
Homepage: http://tulip-software.org/
Standards-Version: 3.9.1

Package: tulip
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ttf-dejavu-core
Suggests: tulip-doc
Description: System dedicated to the visualization of huge graphs
 Tulip is capable of managing graphs with up to 500,000 nodes and edges
 on relatively modest hardware (eg. 600MHz Pentium III, 256MB RAM).
 It includes the following features:
 .
  * 3D visualizations
  * 3D modifications
  * Plug-in support for easy evolution
  * Building of clusters and navigation into them
  * Automatic drawing of graphs
  * Automatic clustering of graphs
  * Automatic selection of elements
  * Automatic metric coloration of graphs

Package: tulip-doc
Architecture: all
Depends: ${misc:Depends}
Suggests: tulip
Section: doc
Description: Documentation for the Tulip graph-visualization system
 This package includes the Tulip User Handbook and the Tulip Developer
 Handbook in HTML format, as well as the manpages for the tulip libraries.

Package: libtulip-3.6
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Tulip graph library - core runtime
 Runtime for tulip, a system dedicated to the visualization of huge graphs.
 .
 This is the core of the system, excluding the OpenGL rendering capabilities.

Package: libtulip-dev
Section: libdevel
Architecture: any
Depends: libtulip-3.6 (= ${binary:Version}), libc6-dev, ${misc:Depends}
Conflicts: libtulip-dev
Replaces: tulip (<= 2), libtulip-ogl-dev, libtulip-qt4-dev
Suggests: automaken, tulip-doc
Description: Tulip graph library - core development files
 Headers and static libraries for tulip, a system dedicated to the
 visualization of huge graphs.
 .
 This is the core of the system, excluding the OpenGL rendering capabilities.

Package: libtulip-ogl-3.6
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Tulip graph library - OpenGL runtime
 Runtime for tulip, a system dedicated to the visualization of huge graphs.
 .
 This library contains the OpenGL rendering capabilities of the engine.

Package: libtulip-qt4-3.6
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Tulip graph library - Qt/OpenGL GUI runtime
 Runtime for tulip, a system dedicated to the visualization of huge graphs.
 .
 This library contains the Qt/OpenGL GUI support.

Package: libtulip-ogdf-3.6
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Tulip graph library - OGDF runtime
 Runtime for tulip, a system dedicated to the visualization of huge graphs.
 .
 This library contains the Open Graph Drawing Framework support.

Package: libogdftlp-3.6
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Open Graph Drawing Framework shared library, built for Tulip
 This is the Open Graph Drawing Framework library, built as a shared
 lib as required by Tulip.

Package: libgzstreamtlp-3.6
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: gzstream shared library, built for Tulip
 C++ iostream classes wrapping the zlib compression library.
 .
 This is the gzstream library, built as a shared lib as required by
 Tulip.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_SKIP_RPATH:BOOL=YES

build-arch:
	dh $@ --parallel
	docbook-to-man debian/tulip.sgml > debian/tulip.1
build-indep:
	#dh $@
	$(MAKE) -C obj-* doc

install-indep: build-indep
	dh_prep -i
	mkdir -p debian/tmp/usr/share/doc/tulip-doc
	set -e; for d in common userHandbook developerHandbook doxygen; do \
		cp -a obj-*/docs/$$d debian/tmp/usr/share/doc/tulip-doc/ ;\
	done
	dh_auto_install -- -C docs
	dh $@

install-arch: build-arch
	dh_prep -a
	install -D debian/tulip.1 debian/tmp/usr/share/man/man1/tulip.1
	dh $@

override_dh_install:
	dh_install --fail-missing

override_dh_auto_clean:
	dh_auto_clean
	rm -f debian/tulip.1
	rm -rf docs/doxygen/xml

binary: binary-arch binary-indep ;

=== debian/watch ===
version=3
http://sf.net/auber/tulip-([\d.]*)(?:-src\.tar\.gz|\.tar\.bz2)
